var directive, getStatsUrl, has2dIndex, hasIndex, hasIndexAsc, hasIndexDesc, hasUniqueIndex;

hasIndex = function(keyName, indexes) {
  var index, _i, _len;
  for (_i = 0, _len = indexes.length; _i < _len; _i++) {
    index = indexes[_i];
    if (_.indexOf(index.keys, keyName) !== -1) {
      return true;
    }
  }
  return false;
};

hasUniqueIndex = function(keyName, indexes) {
  var index, _i, _len;
  for (_i = 0, _len = indexes.length; _i < _len; _i++) {
    index = indexes[_i];
    if (_.indexOf(index.keys, keyName) !== -1) {
      return index.unique;
    }
  }
  return false;
};

hasIndexAsc = function(keyName, indexes) {
  return hasIndex(keyName, indexes);
};

hasIndexDesc = function(keyName, indexes) {
  return hasIndex("-" + keyName, indexes);
};

has2dIndex = function(keyName, indexes) {
  return hasIndex("$2dsphere:" + keyName, indexes);
};

getStatsUrl = function(keyName, routeParams) {
  var r, ret;
  r = routeParams;
  ret = "#/" + r.server + "/" + r.database + "/" + r.collection + "/stats/" + keyName;
  if (r.query) {
    ret = "" + ret + "/query/" + r.query;
  }
  return ret;
};

directive = function() {
  directive = {
    templateUrl: "/partials/directives/key.html",
    replace: true,
    transclude: false,
    restrict: 'E',
    scope: {
      keyName: "=",
      value: "=",
      indexes: "="
    },
    controller: [
      "$scope", "$routeParams", function($scope, $routeParams) {
        $scope.canMakeHistogram = _.isNumber($scope.value);
        $scope.statsUrl = getStatsUrl($scope.keyName, $routeParams);
        $scope.hasIndexDesc = hasIndexDesc($scope.keyName, $scope.indexes);
        $scope.hasIndexAsc = hasIndexAsc($scope.keyName, $scope.indexes);
        $scope.isIndexUnique = hasUniqueIndex($scope.keyName, $scope.indexes);
        $scope.has2DIndex = has2dIndex($scope.keyName, $scope.indexes);
        $scope.showTools = false;
        $scope.hasIndex = $scope.hasIndexDown || $scope.hasIndexUp || $scope.has2DIndex;
        return $scope.getGeoJsonUrl = function() {
          var e, r, url;
          r = $routeParams;
          e = window.encodeURIComponent;
          url = "#/" + r.server + "/" + r.database + "/" + r.collection + "/idx/" + r.idx;
          if (r.query) {
            url = "" + url + "/query/" + (e(r.query));
          }
          return "" + url + "/geojson/" + $scope.keyName;
        };
      }
    ]
  };
  return directive;
};

directives.directive("vulKey", [directive]);
