var directive, mongoJsToMongoJSON, testmongoJsToMongoJSON;

mongoJsToMongoJSON = function(queryString) {
  var DBRef, MaxKey, MinKey, NumberLong, ObjectId, Timestamp, fixQuery, query;
  ObjectId = function(id) {
    return {
      "$oid": id
    };
  };
  DBRef = function(name, id) {
    return {
      "$ref": name,
      "$id": id
    };
  };
  Timestamp = function(t, i) {
    return {
      "t": t,
      "i": i
    };
  };
  NumberLong = function(number) {
    return {
      "$numberLong": String(number)
    };
  };
  MaxKey = {
    "$maxKey": 1
  };
  MinKey = {
    "$minKey": 1
  };
  query = "";
  eval("query = " + queryString);
  fixQuery = function(query) {
    var i, k, option, options, v, _i, _len, _ref;
    if (_.isArray(query)) {
      for (i = _i = 0, _len = query.length; _i < _len; i = ++_i) {
        v = query[i];
        query[i] = fixQuery(v);
      }
      return query;
    }
    if (_.isRegExp(query)) {
      options = "";
      _ref = {
        multiline: "m",
        global: "g",
        ignoreCase: "i"
      };
      for (k in _ref) {
        option = _ref[k];
        if (query[k]) {
          options += option;
        }
      }
      return {
        "$regex": query.source,
        "$options": options
      };
    }
    if (_.isDate(query)) {
      return {
        "$date": query.getTime()
      };
    }
    if (query === void 0) {
      return {
        "$undefined": true
      };
    }
    if (_.isObject(query)) {
      for (k in query) {
        v = query[k];
        query[k] = fixQuery(v);
      }
      return query;
    }
    return query;
  };
  return fixQuery(query);
};

testmongoJsToMongoJSON = function() {
  var assertEqual, s;
  assertEqual = function(a, b) {
    if (!_.isEqual(a, b)) {
      return console.log("error! ", a, " != ", b);
    }
  };
  s = "{a: 89}";
  assertEqual(mongoJsToMongoJSON(s), {
    a: 89
  });
  s = "{a: [1,3,{reg: /allo/gim}]}";
  assertEqual(mongoJsToMongoJSON(s), {
    a: [
      1, 3, {
        reg: {
          "$regex": "allo",
          "$options": "mgi"
        }
      }
    ]
  });
  s = "{a: [\n    1,\n    3,\n    {reg:\n        [/allo/gim,\n         new Date(\"2014-05-08T21:52:24.320Z\")\n         ]\n    }\n    ]\n}";
  return assertEqual(mongoJsToMongoJSON(s), {
    a: [
      1, 3, {
        reg: [
          {
            "$regex": "allo",
            "$options": "mgi"
          }, {
            "$date": 1399585944320
          }
        ]
      }
    ]
  });
};

testmongoJsToMongoJSON();

directive = function() {
  directive = {
    templateUrl: "/partials/directives/searchBar.html",
    replace: true,
    transclude: false,
    restrict: 'E',
    scope: {
      query: "@",
      callback: "="
    },
    controller: [
      "$scope", "$routeParams", function($scope, $routeParams) {
        $scope.bigInput = false;
        $scope.newQuery = $scope.query || "";
        $scope.codeMirrorOptions = {
          lineWrapping: true,
          lineNumbers: true,
          mode: 'text/typescript'
        };
        $scope.parseQueryToJSON = function(query) {
          var error, ret;
          try {
            query = mongoJsToMongoJSON(query);
            ret = JSON.stringify(query);
            $scope.error = "";
            return ret;
          } catch (_error) {
            error = _error;
            $scope.error;
            return "";
          }
        };
        $scope.isValidEntry = function() {
          var query;
          query = $scope.parseQueryToJSON($scope.newQuery);
          return query !== "";
        };
        return $scope.callCallback = function() {
          var f, query;
          query = $scope.parseQueryToJSON($scope.newQuery);
          if (query !== "") {
            f = function() {
              return $scope.callback(query);
            };
            return $scope.$eval(f);
          }
        };
      }
    ]
  };
  return directive;
};

directives.directive("vulSearchBar", [directive]);
