var root;

root = this;

root.filters.filter('escape', function() {
  return window.encodeURIComponent;
});

root.filters.filter('replaceAllCommasBySpaces', function() {
  return function(text) {
    return text.replace(new RegExp(",", "g"), " ");
  };
});

root.filters.filter('niceJSON', function() {
  return function(obj) {
    return JSON.stringify(obj, null, 4);
  };
});

root.filters.filter('replaceReturnByBreak', function() {
  return function(text) {
    return text.replace(new RegExp("\n", "g"), "<br>");
  };
});

root.filters.filter('onlyNthLines', function() {
  return function(text, n) {
    var s;
    if (!_.isString(text)) {
      return "";
    }
    s = text.split("\n");
    return s.slice(0, n).join("\n");
  };
});
